%Generating Spatialy Correlated Data ( 20 trials) over 8 channels
N=20;
C=8;
x=randn(100,C,N);
x(:,1,:)=x(:,2,:)+randn(100,1,N)/3; % Channels 1 and 2 are correlated
y=randn(100,C,N);
y(:,3,:)=y(:,4,:)+randn(100,1,N)/3; % Channels 3 and 4 are correlated
%% Finding Sparse Spatial Filters
Cx=zeros(C,C);
Cy=Cx;
for k=1:N
    Cx=Cx+cov(squeeze(x(:,:,k)));
    Cy=Cy+cov(squeeze(y(:,:,k)));
end
[eVx,eVal] = oscillating_search(Cx,Cy,2,1,'BE'); % Change the Method here
[eVy,eVal] = oscillating_search(Cy,Cx,2,1,'OS');
% Sparse Filters
eVx
eVy
figure(1);
subplot(1,2,1);
stem(eVx)
title('Sparse Spatial Filter')
subplot(1,2,2);
stem(eVy)
title('Sparse Spatial Filter')
%%
V=[eVx eVy];
pX=[];
pY=[];
for k=1:N
p=x(:,:,k)*V;
pX(k,:)=sum(p.^2);
p=y(:,:,k)*V;
pY(k,:)=sum(p.^2);
end

figure(2);
clf;
plot(pX(:,1),pX(:,2),'bo');
hold on;
plot(pY(:,1),pY(:,2),'rx');
legend('X','Y');